IF EXISTS (SELECT name 
   FROM   sysobjects 
   WHERE  name = 'SaveMeasurement' 
   AND   type = 'P')
DROP PROCEDURE SaveMeasurement
GO

CREATE PROCEDURE SaveMeasurement
@SensorName varchar(100),
@MeasurementValue float
AS

DECLARE
@SensorId int,
@SensorTypeId int

if not exists (select * from SENSOR where SensorName = @SensorName)
begin
	select top 1 @SensorTypeId = SensorTypeId from SENSORTYPE order by SensorTypeId
	insert into SENSOR (SensorName, SensorTypeId, Location) values (@SensorName, 1, 'Unknown')
end
else
	select @SensorId = SensorId from SENSOR where SensorName = @SensorName


insert into MEASUREMENT (SensorId, MeasurementValue, MeasurementTimeStamp) 
values (@SensorId, @MeasurementValue, getdate())

GO
